JUCE: KeyboardFocusTraverser Class Reference

JUCE

Public Member Functions | List of all members
KeyboardFocusTraverser Class Reference
juce_gui_basics » keyboard

Controls the order in which keyboard focus moves between components. More...

`#include <juce_KeyboardFocusTraverser.h>`

Inheritance diagram for KeyboardFocusTraverser:

## Public Member Functions
| ~KeyboardFocusTraverser () override=default
| Destructor. More...
Component * | getDefaultComponent (Component *parentComponent) override
| Returns the component that should receive keyboard focus by default within the given parent component. More...
Component * | getNextComponent (Component *current) override
| Returns the component that should be given keyboard focus after the specified one when moving "forwards". More...
Component * | getPreviousComponent (Component *current) override
| Returns the component that should be given keyboard focus after the specified one when moving "backwards". More...
std::vector< Component * > | getAllComponents (Component *parentComponent) override
| Returns all of the components that can receive keyboard focus within the given parent component in traversal order. More...
Public Member Functions inherited from ComponentTraverser
virtual | ~ComponentTraverser ()=default
| Destructor. More...
virtual Component * | getDefaultComponent (Component *parentComponent)=0
| Returns the component that should be used as the traversal entry point within the given parent component. More...
virtual Component * | getNextComponent (Component *current)=0
| Returns the component that comes after the specified one when moving "forwards". More...
virtual Component * | getPreviousComponent (Component *current)=0
| Returns the component that comes after the specified one when moving "backwards". More...
virtual std::vector< Component * > | getAllComponents (Component *parentComponent)=0
| Returns all of the traversable components within the given parent component in traversal order. More...

## Detailed Description

Controls the order in which keyboard focus moves between components.

The default behaviour of this class uses a FocusTraverser object internally to determine the default/next/previous component until it finds one which wants keyboard focus, as set by the Component::setWantsKeyboardFocus() method.

If you need keyboard focus traversal in a more customised way, you can create a subclass of ComponentTraverser that uses your own algorithm, and use Component::createKeyboardFocusTraverser() to create it.

See also
  FocusTraverser, ComponentTraverser, Component::createKeyboardFocusTraverser

## Constructor & Destructor Documentation

## ◆ ~KeyboardFocusTraverser()

KeyboardFocusTraverser::~KeyboardFocusTraverser | ( |  | ) |
| overridedefault

Destructor.

## Member Function Documentation

## ◆ getDefaultComponent()

Component * KeyboardFocusTraverser::getDefaultComponent | ( | Component * | parentComponent | ) |
| overridevirtual

Returns the component that should receive keyboard focus by default within the given parent component.

The default implementation will return the foremost focusable component (as determined by FocusTraverser) that also wants keyboard focus, or nullptr if there is no suitable component.

Implements ComponentTraverser.

## ◆ getNextComponent()

Component * KeyboardFocusTraverser::getNextComponent | ( | Component * | current | ) |
| overridevirtual

Returns the component that should be given keyboard focus after the specified one when moving "forwards".

The default implementation will return the next focusable component (as determined by FocusTraverser) that also wants keyboard focus, or nullptr if there is no suitable component.

Implements ComponentTraverser.

## ◆ getPreviousComponent()

Component * KeyboardFocusTraverser::getPreviousComponent | ( | Component * | current | ) |
| overridevirtual

Returns the component that should be given keyboard focus after the specified one when moving "backwards".

The default implementation will return the previous focusable component (as determined by FocusTraverser) that also wants keyboard focus, or nullptr if there is no suitable component.

Implements ComponentTraverser.

## ◆ getAllComponents()

std::vector< Component * > KeyboardFocusTraverser::getAllComponents | ( | Component * | parentComponent | ) |
| overridevirtual

Returns all of the components that can receive keyboard focus within the given parent component in traversal order.

The default implementation will return all focusable child components (as determined by FocusTraverser) that also wants keyboard focus.

Implements ComponentTraverser.

The documentation for this class was generated from the following file:

- juce_KeyboardFocusTraverser.h